#include "habitacion.h"

habitacion::habitacion(){
	//Dudo que haya mas de 20 portales en una habitacion :)
	portal=new float*[20];
	for (int cont=0;cont<20;cont++) portal[cont]=0;
	portalNeighbour=new int[20];
	numPortals=0;
	numItems=0;
	numWeapons=0;


	faces=0;
	vertex=0;
	textureVertex=0;
	textureFaces=0;

	itemObj=new item[100];
	weaponObj=new item[100]; 
}


habitacion::~habitacion(){

	if (faces) delete[] faces;
	if (vertex) delete[] vertex;
	if (textureFaces) delete[] textureFaces;
	if (textureVertex) delete[] textureVertex;
	delete[] portalNeighbour;
	delete[] itemObj;
	for (int i=0;i<numPortals;i++){
		if (portal[i]) delete portal[i];
	}
	delete[] portal;

}




bool habitacion::setPortalVertex(int number, float *portalV){
	if (number<0 || number>numPortals) return false;
	portal[number]=new float[12];
	memcpy(portal[number],portalV,sizeof(float)*12);
	return true;
}

bool habitacion::setPortalNeighbour(int neighbour){
	portalNeighbour[numPortals]=neighbour;
	numPortals++;
	return true;
}


int habitacion::getNumPortals(){
	return numPortals;
}

void habitacion::setNumItems(int num){
	numItems=num;
}

int habitacion::getNumItems(){
	return numItems;
}

item &habitacion::getItem(int pos){
	return itemObj[pos];
}

void habitacion::setNumWeapons(int num){
	numWeapons=num;
}

int habitacion::getNumWeapons(){
	return numWeapons;
}

item &habitacion::getWeapon(int pos){
	return weaponObj[pos];
}

void habitacion::setVertex(float *vertex_,int numVertex_){
	numVertex=numVertex_;
	vertex=new float[numVertex*3];
	memcpy(vertex,vertex_,sizeof(float)*numVertex*3);
}

float *habitacion::getVertex(){
	return vertex;
}

void habitacion::setTextureVertex(float *textureVertex_, int numTextureVertex_){
	numTextureVertex=numTextureVertex_;
	textureVertex=new float[numTextureVertex*2];
	memcpy(textureVertex,textureVertex_,sizeof(float)*numTextureVertex*2);
}

float *habitacion::getTextureVertex(){
	return textureVertex;
}

void habitacion::setFaces(int *faces_, int numFaces_){

	numFaces=numFaces_;
	faces=new int[numFaces*4];
	memcpy(faces,faces_,sizeof(int)*numFaces*4);
}

int *habitacion::getFaces(){
	return faces;
}

void habitacion::setTextureFaces(int *textureFaces_, int numTextureFaces_){
	numTextureFaces=numTextureFaces_;
	textureFaces=new int[numTextureFaces*3];
	memcpy(textureFaces,textureFaces_,sizeof(int)*numTextureFaces*3);
}

int *habitacion::getTextureFaces(){
	return textureFaces;
}

int habitacion::getNumVertex(){
	return numVertex;
}

int habitacion::getNumTextureVertex(){
	return numTextureVertex;
}

int habitacion::getNumFaces(){
	return numFaces;
}

int habitacion::getNumTextureFaces(){
	return numTextureFaces;
}

void habitacion::setMaterialRef(int mat){
	materialRef=mat;
}

int habitacion::getMaterialRef(){
	return materialRef;
}

int habitacion::getPortalNeighbour(int neighbour){
	if (neighbour<0 || neighbour >= numPortals) killProgram(0,"Trying to acces an invalid portal neighbour");
	return portalNeighbour[neighbour];
}

float habitacion::getPortalVertex(int which,int vertex_){
	if (!portal[which])killProgram(0,"Trying to acces an invalid portal vertex");
	if (which<0 || which >= numPortals || vertex_<0 || vertex_>=12) killProgram(0,"Trying to acces an invalid portal vertex");
	return portal[which][vertex_];
}



