#include "main.h"

int main(int argc, char** argv){

	//Inicializamos variables
	file_name=new char[30];
	tempoString=new char[100];
	startObj=new start[100];

		
	//Empieza el programa
	printf("MAP CONVERSOR V.2.0 BY ANKH 2003\n\n");
	
	//Le pongo el directorio de trabajo
	printf("SET FILE DIRECTORY: ");
	scanf("%s",file_name);
	chdir(file_name);
	
	printf("SET AUDIO FILENAME: ");
	scanf("%s",audioFile);

	//Pido el archivo de origen
	printf("ORIGINAL FILE: ");
	scanf("%s",file_name);
	
	origen=fopen(file_name,"r");
	if (!origen) killProgram(0,"Original file not founded\n");
	
	loadInfo();
	
	//Pido el archivo de destino
	printf("\nDESTINY FILE: ");
	scanf("%s",file_name);

	destino=fopen(file_name,"w");
	if (!destino) killProgram(0,"Destiny file couldn't be created\n");

	writeInfo();

	killProgram(1);
	return 1;
}

void loadInfo(){

	//Buscamos el numero de habitaciones
	while (buscaPalabra("*GROUP")) numHab++;
	if (!numHab) killProgram(0,"No rooms founded\n");
	printf("HABITACIONES: %d\n",numHab);

	rewind(origen);
	
	//Creamos la clase habitacion
	habs=new habitacion*[numHab];
	for (cont=0;cont<numHab;cont++){
		habs[cont]=new habitacion();
	}

    /*
	//
    //Cargamos texturas!!!
	//
	*/

	if (buscaPalabra("*MATERIAL_COUNT")) fscanf(origen,"%d",&numDifTextures);
	printf("NUM TEXTURES: %d\n\n",numDifTextures);
	text=new texture*[numDifTextures];

	bool textureUsed=false;
	//Buscamos las texturas
	for (cont=0;cont<numDifTextures && !feof(origen);cont++){
		int numSubTex,temporal;
		
		text[cont]=new texture();

		//Buscamos el numero de subtexturas para esa textura
		temporal=buscaPalabra("*NUMSUBMTLS","*MAP_DIFFUSE");
		if (temporal==0) {
			printf("\nTEXTURE %d\n",cont);
			if (buscaPalabra("*BITMAP","}")>0){

			textureUsed=false;
			//Lee solamente la parte de la textura que nos interesa
				if(!readFile(tempoString))killProgram(0,"Error reading texture bitmap");

					//Comprobamos que el bitmap encontrado no este repetido
				for (cont3=0;cont3<numTextures;cont3++){
					if (!strcmp(textures[cont3],tempoString)) {
						
						textureUsed=true;

						//Guardamos el submaterial y a que textura apunta
						text[cont]->setTexturePointer(cont3);
						printf("  TEXTURE 0 ALREDY USED: %d (%s)\n",cont3,textures[cont3]);
					}
				}

				//Si se cumple esta condicion significa que es una textura nueva
				if (!textureUsed){

				//Guardamos el nombre de esta
					strcpy(textures[numTextures],tempoString);

					//El submaterial este apunta a la nueva textura
					text[cont]->setTexturePointer(numTextures);

					printf("  TEXTURE 0 (%d -> %s) ADDED\n",numTextures,textures[numTextures]);

					//Ya hay una textura mas :)
					numTextures++;
				}
			}
			else if (feof(origen)) killProgram(0,"Error reading textures");
			//Si no tiene bitmap apunta a la textura -1
			else {
			//habs[cont]->setTexturePointer(cont2,-1);
				printf("  TEXTURE %d HAS NO TEXTURE\n",cont);
			}
		}
		else if (temporal==-1) killProgram (0,"Couldn't find number of subTextures");
		else{
			fscanf(origen,"%d",&numSubTex);
			printf("\nTEXTURE %d NUM_SUBTEX: %d\n",cont,numSubTex);

			//Leemos todas las subtexturas
			for (cont2=0;cont2<numSubTex && !feof(origen);cont2++){

				textureUsed=false;

				if (!buscaPalabra("*SUBMATERIAL")) killProgram(0,"Wrong number of Submaterials");
				//Miramos si la subtextura tiene bitmap o no. Si no tiene primero encontrara
				//un }
				if (buscaPalabra("*BITMAP","}")>0){

					//Lee solamente la parte de la textura que nos interesa
					if(!readFile(tempoString))killProgram(0,"Error reading texture bitmap");

					//Comprobamos que el bitmap encontrado no este repetido
					for (cont3=0;cont3<numTextures;cont3++){
						if (!strcmp(textures[cont3],tempoString)) {
							
							textureUsed=true;

							//Guardamos el submaterial y a que textura apunta
						text[cont]->setTexturePointer(cont3);
							printf("  TEXTURE %d ALREDY USED: %d (%s)\n",cont2,cont3,textures[cont3]);
						}
					}

					//Si se cumple esta condicion significa que es una textura nueva
					if (!textureUsed){

						//Guardamos el nombre de esta
						strcpy(textures[numTextures],tempoString);

						//El submaterial este apunta a la nueva textura
						text[cont]->setTexturePointer(numTextures);

						printf("  TEXTURE %d (%d -> %s) ADDED\n",cont2,numTextures,textures[numTextures]);

						//Ya hay una textura mas :)
						numTextures++;
					}
				}
				else if (feof(origen)) killProgram(0,"Error reading textures");
				//Si no tiene bitmap apunta a la textura -1
				else {
	//				habs[cont]->setTexturePointer(cont2,-1);
					printf("  TEXTURE %d HAS NO TEXTURE\n",cont2);
				}
			}
		}
	}


	/*
	//
    //Cargamos el resto!!!
	//
	*/

	//Buscamos el comienzo del mapa
	if (!buscaPalabra("*GROUP")) killProgram(0,"Error looking for room");
	if (!readFirstWord(tempoString)) killProgram(0,"Error reading room");
	if (!readSecondWord(tempoString)) killProgram(0,"Error reading room number");

	int actualHab=atoi(tempoString);
	
	for (cont=0;cont<numHab;cont++){
		printf("Loading Room %d\n",actualHab);
		while (buscaPalabra("*NODE_NAME","*GROUP")>0){
			if (!readFirstWord(tempoString)) killProgram(0,"Error reading element type");
			
			if (!strcmp(tempoString,"PORTAL")){
				printf("  -Loading portal\n");
				if (!readSecondWord(tempoString)) killProgram(0,"Error reading portal neighbour");
				habs[actualHab]->setPortalNeighbour((int)atoi(tempoString));

				if (!buscaPalabra("*MESH_VERTEX_LIST"))killProgram(0,"Error loading portal vertex");

				fscanf(origen,"%s",tempoString);

				float *vertex;
				vertex=new float[12];
				for (cont2=0;cont2<12;cont2+=3){
					fscanf(origen,"%s",tempoString);
					fscanf(origen,"%s",tempoString);

					fscanf(origen,"%f %f %f",&vertex[cont2],&vertex[cont2+2],&vertex[cont2+1]);
					vertex[cont2]=-vertex[cont2];
					
				}
				habs[actualHab]->setPortalVertex(habs[actualHab]->getNumPortals()-1,vertex);
				
				delete[] vertex;

			//	if (!buscaPalabra("*WIREFRAME_COLOR")) killProgram(0,"Error loading room");

			}

			else if (!strcmp(tempoString,"START")){
				printf("  -Loading Start Point\n");
				
				if (!buscaPalabra("*TM_POS")) killProgram(0,"Error loading start point pos");

				float pos[3];
				fscanf(origen,"%f %f %f",&pos[0],&pos[2],&pos[1]);
				pos[0]=-pos[0];
				startObj[numStarts].setPos(pos);
				if (!buscaPalabra("*TM_ROTANGLE")) killProgram(0,"Error loading start point angle");
				
				fscanf(origen,"%f",&startObj[numStarts].rot);

				startObj[numStarts].id=actualHab;
				numStarts++;
				
			}
			else if (!strcmp(tempoString,"ITEM")){
				if (!readSecondWord(tempoString)) killProgram(0,"Error reading item name");
				printf("    Hab: %d Item: %s\n",actualHab, tempoString);
				bool nuevo=true;
				int itemNumber;
				for (itemNumber=0;itemNumber<numItemModel && nuevo;itemNumber++){
					if (!strcmp(tempoString,itemModel[itemNumber])) nuevo=false;
				}
				if (nuevo) {
					strcpy(itemModel[numItemModel],tempoString);
					habs[actualHab]->getItem(habs[actualHab]->getNumItems()).id=numItemModel;
					printf("  -New Item created. Id: %d\n",numItemModel);
					numItemModel++;
				}
				else{
					habs[actualHab]->getItem(habs[actualHab]->getNumItems()).id=itemNumber-1;
					printf("  -Item created. Id: %d\n",itemNumber-1);
				}

				if (!buscaPalabra("*TM_POS")) killProgram (0, "Couldn't find item pos");

				float vertex[3];

				fscanf(origen,"%f %f %f",&vertex[0],&vertex[2],&vertex[1]);
				vertex[0]*=-1;
				habs[actualHab]->getItem(habs[actualHab]->getNumItems()).setPos(vertex);
				habs[actualHab]->setNumItems(habs[actualHab]->getNumItems()+1);
				numItems++;
			}

			else if (!strcmp(tempoString,"WEAPON")){
				if (!readSecondWord(tempoString)) killProgram(0,"Error reading weapon name");
				printf("    Hab: %d Weapon: %s\n",actualHab, tempoString);
				
				bool nuevo=true;
				int weaponNumber;
				for (weaponNumber=0;weaponNumber<numWeaponModel && nuevo;weaponNumber++){
					if (!strcmp(tempoString,weaponModel[weaponNumber])) nuevo=false;
				}
				if (nuevo) {
					strcpy(weaponModel[numWeaponModel],tempoString);
					habs[actualHab]->getWeapon(habs[actualHab]->getNumWeapons()).id=numWeaponModel;
					printf("  -New Weapon created. Id: %d\n",numWeaponModel);
					numWeaponModel++;
				}
				else{
					habs[actualHab]->getWeapon(habs[actualHab]->getNumWeapons()).id=weaponNumber-1;
					printf("  -Weapon created. Id: %d\n",weaponNumber-1);
				}

				if (!buscaPalabra("*TM_POS")) killProgram (0, "Couldn't find item pos");

				float vertex[3];

				fscanf(origen,"%f %f %f",&vertex[0],&vertex[1],&vertex[2]);
				habs[actualHab]->getWeapon(habs[actualHab]->getNumWeapons()).setPos(vertex);
				habs[actualHab]->setNumWeapons(habs[actualHab]->getNumWeapons()+1);
				numItems++;
			}
			else if (!strcmp(tempoString,"HAB")){
				printf("  -Loading Hab\n");

				int numVertex, numFaces;

				if (!buscaPalabra("*MESH_NUMVERTEX")) killProgram(0,"Error looking for number of vertex");
				fscanf(origen,"%d",&numVertex);

				arrayFloat=new float[numVertex*3];

				if (!buscaPalabra("*MESH_NUMFACES")) killProgram(0,"Error looking for number of faces");
				fscanf(origen,"%d",&numFaces);

				arrayInt=new int[numFaces*4];

				for (cont2=0;cont2<numVertex*3;cont2+=3){
					if (buscaPalabra("*MESH_VERTEX","}")<=0) killProgram(0,"Wrong number of vertex");
					fscanf(origen,"%d",&tempoInt);
					fscanf(origen,"%f %f %f",&arrayFloat[cont2],&arrayFloat[cont2+2],&arrayFloat[cont2+1]);
					arrayFloat[cont2]=-arrayFloat[cont2];
				}

				habs[actualHab]->setVertex(arrayFloat,numVertex);

				delete[] arrayFloat;
				printf("    *Vertex Loaded\n");

				if (!buscaPalabra("*MESH_FACE_LIST")) killProgram(0,"Error looking for faces");
				for (cont2=0;cont2<numFaces*4;cont2+=4){
					if (buscaPalabra("*MESH_FACE","}")<=0) killProgram(0,"Wrong number of faces");
					fscanf(origen,"%s",tempoString);
					
					fscanf(origen,"%s",tempoString);
					fscanf(origen,"%d",&arrayInt[cont2]);
		
					fscanf(origen,"%s",tempoString);
					fscanf(origen,"%d",&arrayInt[cont2+1]);

					fscanf(origen,"%s",tempoString);
					fscanf(origen,"%d",&arrayInt[cont2+2]);

					for (cont3=0;cont3<9;cont3++) fscanf(origen,"%s",tempoString);
					fscanf(origen,"%d",&arrayInt[cont2+3]);
				}

				habs[actualHab]->setFaces(arrayInt,numFaces);

				delete[] arrayInt;

				printf("    *Faces Loaded\n");

				if (!buscaPalabra("*MESH_NUMTVERTEX"))killProgram(0,"Error looking for number of texture vertex");
				fscanf(origen,"%d",&numVertex);

				arrayFloat=new float[numVertex*2];

				if (!buscaPalabra("*MESH_TVERTLIST")) killProgram(0,"Error looking for texture vertex");
				for (cont2=0;cont2<numVertex*2;cont2+=2){
					if (buscaPalabra("*MESH_TVERT","}")<=0) killProgram(0,"Wrong number of texture vertex");
					fscanf(origen,"%d",&tempoInt);
					fscanf(origen,"%f %f %f",&arrayFloat[cont2],&arrayFloat[cont2+1],&tempoInt);
				}

				habs[actualHab]->setTextureVertex(arrayFloat,numVertex);

				delete[] arrayFloat;
				printf("    *Texture Vertex Loaded\n");

				if (!buscaPalabra("*MESH_NUMTVFACES")) killProgram(0,"Error looking for number of texture faces");
				fscanf(origen,"%d",&numFaces);

				arrayInt=new int[numFaces*3];

				if (!buscaPalabra("*MESH_TFACELIST")) killProgram(0,"Error looking for texture faces");
				for (cont2=0;cont2<numFaces*3;cont2+=3){
					if (buscaPalabra("*MESH_TFACE","}")<=0) killProgram(0,"Wrong number of texture faces");
					fscanf(origen,"%d",&tempoInt);
					fscanf(origen,"%d %d %d",&arrayInt[cont2],&arrayInt[cont2+1],&arrayInt[cont2+2]);
				}

				habs[actualHab]->setTextureFaces(arrayInt,numFaces);

				delete[] arrayInt;
				printf("    *Texture Faces Loaded\n");

				if (!buscaPalabra("*MATERIAL_REF")) killProgram(0,"This room hasn't got a texture");
				fscanf(origen,"%d",&tempoInt);
				habs[actualHab]->setMaterialRef(tempoInt);

			}
		
			else if (!buscaPalabra("*MESH")) killProgram(0,"Error loading room");

		
		}
	
		if ((cont+1)==numHab) break;
		else if (feof(origen))	killProgram(0,"Room has no end");
		
		if (!readFirstWord(tempoString)) killProgram(0,"Error reading room");
		if (!readSecondWord(tempoString)) killProgram(0,"Error reading room number");

		actualHab=atoi(tempoString);
				
		
	}

	

}



void writeInfo(){

	fprintf(destino,"NUMERO_HABITACIONES %d\n",numHab);
	fprintf(destino,"NUMERO_ITEMS %d\n",numItems);
	fprintf(destino,"NUMERO_ARMAS %d\n",numWeaponModel);
	fprintf(destino,"NUMERO_MODELOS_ITEMS %d\n",numItemModel);
	for (cont=0;cont<numItemModel;cont++){
		fprintf(destino,"ITEM %d %s\n",cont,itemModel[cont]);
	}
	for (cont=0;cont<numWeaponModel;cont++){
		fprintf(destino,"WEAPON %d %s\n",cont,weaponModel[cont]);
	}
	fprintf(destino,"NUM_TEXTURES %d\n",numTextures);
	for (cont=0;cont<numTextures;cont++){
		fprintf(destino,"TEXTURE %d %s\n",cont,textures[cont]);
	}
	fprintf(destino,"NUM_STARTS %d\n",numStarts);
	for (cont=0;cont<numStarts;cont++){
		fprintf(destino,"START %d\n"
			"%f %f %f %f\n",startObj[cont].id,startObj[cont].x,startObj[cont].y,startObj[cont].z,startObj[cont].rot);
	}
	char *PVS=getFileName(file_name);
	fprintf(destino,"PVS %s.pvs\n",PVS);
	fprintf(destino,"AUDIO %s\n",audioFile);
	fprintf(destino,"RATIO 0.001\n");
	delete[] PVS;

	printf("Textures writed\n");

	for (cont=0;cont<numHab;cont++){

		printf("WRITING ROOM %d\n",cont);
		fprintf(destino,"\nHABITACION %d\n",cont);
		fprintf(destino,"NUM_PORTALS %d\n",habs[cont]->getNumPortals());
		for (cont2=0;cont2<habs[cont]->getNumPortals();cont2++){
			fprintf(destino,"ELEMENTO PORTAL %d\n",habs[cont]->getPortalNeighbour(cont2));
			for (cont3=0;cont3<12;cont3+=3){
				fprintf(destino,"%f %f %f\n",habs[cont]->getPortalVertex(cont2,cont3),habs[cont]->getPortalVertex(cont2,cont3+1),habs[cont]->getPortalVertex(cont2,cont3+2));
			}
		}

		printf("  -Portals writed\n");

		for (cont2=0;cont2<habs[cont]->getNumItems();cont2++){
			fprintf(destino,"ELEMENTO ITEM %d\n",habs[cont]->getItem(cont2).id);
			fprintf(destino,"%f %f %f\n",habs[cont]->getItem(cont2).x,habs[cont]->getItem(cont2).y,habs[cont]->getItem(cont2).z);
			
		}
			printf("  -Items writed\n");
			for (cont2=0;cont2<habs[cont]->getNumWeapons();cont2++){
				fprintf(destino,"ELEMENTO WEAPON %d\n",habs[cont]->getWeapon(cont2).id);
				printf("    Weapon: %d\n",habs[cont]->getWeapon(cont2).id);
				fprintf(destino,"%f %f %f\n",habs[cont]->getWeapon(cont2).x,habs[cont]->getWeapon(cont2).y,habs[cont]->getWeapon(cont2).z);
				printf("ELEMENTO WEAPON %d -> %s\n",habs[cont]->getWeapon(cont2).id,weaponModel[habs[cont]->getWeapon(cont2).id]);
				printf("%f %f %f\n",habs[cont]->getWeapon(cont2).x,habs[cont]->getWeapon(cont2).y,habs[cont]->getWeapon(cont2).z);
			
			}
			printf("  -Weapons writed\n");

			fprintf(destino,"ELEMENTO HAB\n");
			fprintf(destino,"NUM_VERTEX %d\n",habs[cont]->getNumVertex());

			arrayFloat=habs[cont]->getVertex();
			for (cont2=0;cont2<habs[cont]->getNumVertex()*3;cont2+=3){
				fprintf(destino,"%f %f %f\n",arrayFloat[cont2],arrayFloat[cont2+1],arrayFloat[cont2+2]);
			}

			printf("    *Vertex writed\n");

			fprintf(destino,"NUM_FACES %d\n",habs[cont]->getNumFaces());

			arrayInt=habs[cont]->getFaces();
			
			for (cont2=0;cont2<habs[cont]->getNumFaces()*4;cont2+=4){

				fprintf(destino,"%d %d %d %d\n",arrayInt[cont2],arrayInt[cont2+1],arrayInt[cont2+2],text[habs[cont]->getMaterialRef()]->getTexturePointer(arrayInt[cont2+3]));
			}
			printf("    *Faces writed\n");

			fprintf(destino,"NUM_TEXTURE_VERTEX %d\n",habs[cont]->getNumTextureVertex());

			arrayFloat=habs[cont]->getTextureVertex();
			for (cont2=0;cont2<habs[cont]->getNumTextureVertex()*2;cont2+=2){
				fprintf(destino,"%f %f\n",arrayFloat[cont2],arrayFloat[cont2+1]);
			}

			printf("    *Texture vertex writed\n");
			fprintf(destino,"NUM_TEXTURE_FACES %d\n",habs[cont]->getNumTextureFaces());
			
			arrayInt=habs[cont]->getTextureFaces();
			for (cont2=0;cont2<habs[cont]->getNumTextureFaces()*3;cont2+=3){
				fprintf(destino,"%d %d %d\n",arrayInt[cont2],arrayInt[cont2+1],arrayInt[cont2+2]);
			}

			printf("    *Texture Faces writed\n");
		

	}
}


bool buscaPalabra(char *palabra){

	char *tempo;
	tempo = new char[100];

	do {
		fscanf(origen,"%s",tempo);
	}while (strcmp(palabra,tempo) && !feof(origen));

	delete[] tempo;

	if (feof(origen)) return false;
	return true;

}

int buscaPalabra(char *palabra, char *palabra2){

	int tipo;

	char *tempo;
	tempo = new char[100];

	do {
		fscanf(origen,"%s",tempo);
	}while (strcmp(palabra,tempo) && strcmp(palabra2,tempo) && !feof(origen));

	if (!strcmp(palabra,tempo)) tipo = 1;
	else if (!strcmp(palabra2,tempo)) tipo = 0;
	else if (feof(origen)) tipo=-1;
	
	delete[] tempo;
	
	return tipo;

}


bool readFile(char *ruta){

	int i=0;

	fscanf(origen," %c",&ruta[0]);
	if (ruta[0]!='"') return false;

	ruta[0]=0;

	for (i=0;!feof(origen);i++){
		fscanf(origen,"%c",&ruta[i]);
		if (ruta[i]=='"') break;
		else if (ruta[i]=='\\')	i=-1;
		else if (ruta[i]=='\n') return false;		
	}

	if (feof(origen)) return false;
	
	ruta[i]=0;

	return true;
}

bool readFirstWord(char *ruta){

	int i=0;

	fscanf(origen," %c",&ruta[0]);
	if (ruta[0]!='"') return false;

	ruta[0]=0;

	for (i=0;!feof(origen);i++){
		fscanf(origen,"%c",&ruta[i]);
		if (ruta[i]=='"' || ruta[i]==' ') break;
		else if (ruta[i]=='\n') return false;		
	}

	if (feof(origen)) return false;
	
	ruta[i]=0;

	return true;
}

bool readSecondWord(char *ruta){

	int i=0;

	for (i=0;!feof(origen);i++){
		fscanf(origen,"%c",&ruta[i]);
		if (ruta[i]=='"') break;
		else if (ruta[i]=='\n') return false;		
	}

	if (feof(origen)) return false;
	
	ruta[i]=0;

	return true;
}

void killProgram (int type, char *reason){

	int i;

	if (!type) printf("\nASE2MPH EXCEPTION: %s\n"
					   "EXECUTION ABORTED\n", reason);
	else printf("\nPROGRAM FINALIZED CORRECTLY\n");

	if (origen) fclose(origen);
	if (destino) fclose(destino);
	delete[] file_name;
	delete[] tempoString;
	if (habs) {
		for (i=0;i<numHab;i++){
			delete habs[i];
		}
		delete[] habs;
	}
	if (startObj) delete[] startObj;

	printf("\nMAP CONVERSOR V.2.0 BY ANKH 2003\n");
	exit(type);
}

char *getFileName(char *file){
	char *fileName;
	int i;
	fileName=new char[15];

	for (i=0;file[i] && file[i]!='.';i++) fileName[i]=file[i];
	fileName[i]=0;

	return fileName;

}

